﻿using ComponentPractice.Data;
using ComponentPractice.Models;
using ComponentPractice.Services;
using Microsoft.AspNetCore.Mvc;

namespace ComponentPractice.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class ExportController : ControllerBase
    {
        private InMemoryData _inMemoryData;
        private ToCSVService _toCsvService;

        public ExportController(InMemoryData inMemoryData, ToCSVService toCsvService)
        {
            _inMemoryData = inMemoryData;
            _toCsvService = toCsvService;
        }

        //[HttpGet("/InMemoryData/FixedEmployees/csv")] // 절대경로 주의!
        [HttpGet("InMemoryData/FixedEmployees/csv")]
        public async Task<FileStreamResult> ExportToCSV()
        {
            List<Employee> employees = await _inMemoryData.GetFixedEmployeeDataAsync();
            IQueryable query = _toCsvService.ApplyQuery(employees.AsQueryable(), Request.Query);
            return _toCsvService.ToCSV(query);
        }
    }
}
